﻿Imports System.IO
Imports System.Text.RegularExpressions

Public Class Form1
    ' Start in the test directory.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim dir_info As New DirectoryInfo( _
            Path.Combine(Application.StartupPath, "..\..\Test"))
        txtDirectory.Text = dir_info.FullName
    End Sub

    ' Make a list of file names to change from and to.
    Private FullFromNames, FromNames, ToNames As List(Of String)
    Private Sub MakeFileLists()
        Try
            ' Make the file name lists.
            FullFromNames = New List(Of String)()
            FromNames = New List(Of String)()
            ToNames = New List(Of String)()

            ' Get the files that match the pattern.
            Dim dir_info As New DirectoryInfo(txtDirectory.Text)
            Dim files() As FileInfo = dir_info.GetFiles(txtFilePattern.Text)
            Dim reg_ex As New Regex(txtOldPattern.Text)
            For i As Integer = 0 To files.Length - 1
                Dim new_name As String = reg_ex.Replace(files(i).Name, txtNewPattern.Text)
                new_name = new_name.Replace("$i", i.ToString())
                If (files(i).Name <> new_name) Then
                    FullFromNames.Add(files(i).FullName)
                    FromNames.Add(files(i).Name)
                    ToNames.Add(new_name)
                End If
            Next i
        Catch ex As Exception
            MessageBox.Show("Error building file list.\n" & ex.Message)
            FullFromNames = New List(Of String)()
            FromNames = New List(Of String)()
            ToNames = New List(Of String)()
        End Try
    End Sub

    ' Display a list of changes that we will make.
    Private Sub btnPreviewChanges_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPreviewChanges.Click
        ' Make the file lists.
        MakeFileLists()

        ' Display the lists.
        lvwResults.Items.Clear()
        For i As Integer = 0 To FromNames.Count - 1
            Dim new_item As ListViewItem = lvwResults.Items.Add(FromNames(i))
            new_item.SubItems.Add(ToNames(i))
        Next i
        lvwResults.Columns(0).Width = -2
        lvwResults.Columns(1).Width = -2

        ' Enable the Make Changes button.
        btnMakeChanges.Enabled = True
    End Sub

    ' Make the changes.
    Private Sub btnMakeChanges_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMakeChanges.Click
        Try
            For i As Integer = 0 To FromNames.Count - 1
                Try
                    Dim file_info As New FileInfo(FullFromNames(i))
                    Dim new_name As String = file_info.DirectoryName & "\" & ToNames(i)

                    file_info.MoveTo(new_name)
                    'Console.WriteLine(i.ToString() & ": " & file_info.FullName & " --> " & new_name)
                Catch ex As Exception
                    MessageBox.Show("Error moving file '" & _
                        FromNames(i) & "' to '" & _
                        ToNames(i) & "'.\n" & ex.Message)
                    Throw
                End Try
            Next i

            lvwResults.Items.Clear()
            btnMakeChanges.Enabled = False
            FullFromNames = New List(Of String)()
            FromNames = New List(Of String)()
            ToNames = New List(Of String)()

            MessageBox.Show("Done")
        Catch
        End Try
    End Sub

    ' Remove the selected files from the ListView.
    Private Sub btnRemoveFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemoveFile.Click
        For i As Integer = lvwResults.Items.Count - 1 To 0 Step -1
            If (lvwResults.Items(i).Selected) Then
                lvwResults.Items.RemoveAt(i)
                FromNames.RemoveAt(i)
                ToNames.RemoveAt(i)
            End If
        Next i
    End Sub
End Class
